.nolist
    include     \masm32\include\masm32rt.inc    ; defaults to .386
    .586
    include     timers.asm      ; requires a pentium

    LOOPCOUNT equ 100000;0

    PROCS TEXTEQU <szCmpix,szCmpix2,szCmpix3>
    LastString= 999
;    SIZES TEXTEQU <0,1,2,3,5,8,13,22,39,55,89,144,239,LastString>

;    HPROC TEXTEQU <szLen>        ; Function to calculate length for header
.listall
    %FOR proc,<PROCS>
        proc proto :DWORD,:DWORD,:DWORD
    ENDM

    MAXWIDTH  equ 20
    HDRWIDTH  equ 9
    COLWIDTH  equ 5

;.data
;
;    %FOR extra,<0,1,2,3>
;        %FOR len,<SIZES>
;            align 16
;            db extra dup (0)
;            str&extra&b&len& db len dup (254),0
;            db 8 dup (255),0    ; possible next string
;        ENDM
;    ENDM
;
    .data
    align 16
    @_cmpi_table_@ \
      db   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15
      db  16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31
      db  32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47
      db  48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63
      db  64, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111
      db 112,113,114,115,116,117,118,119,120,121,122, 91, 92, 93, 94, 95
      db  96, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111
      db 112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127
      db 128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143
      db 144,145,146,147,148,149,150,151,152,153,154,155,156,156,158,159
      db 160,161,162,163,164,165,166,167,168,169,170,171,172,173,173,175
      db 176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
      db 192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207
      db 208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223
      db 224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239
      db 240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255

align 16
;	str1 db "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
;	str2 db "abcdefghijklmnopqrstuvwx.yz"
	str1 db "AbCdEfGhIjKlMnOpQrStUvWxYz123456789...."
	str2 db "aBcDeFgHiJkLmNoPqRsTuVwXyZ123456780...."
    .code
align 16

sxFld proc DDpointer:DWORD, rvstring:DWORD, DDwidth:DWORD, DDalign:DWORD
    .if DDalign == 0                    ; align left?
        invoke szLeft,DDpointer,rvstring,DDwidth
        invoke szLen,rvstring
        mov edx,rvstring
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+eax],32
        inc eax
        jmp @B
    @@: mov byte ptr [edx+eax],0
    .elseif DDalign == 1                ; align right?
        invoke szLen,DDpointer
        mov edx,rvstring
        xor ecx,ecx
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+ecx],32
        inc eax
        inc ecx
        jmp @B
    @@: add edx,ecx
        invoke szLeft,DDpointer,edx,DDwidth
    .endif
    ret 4*4

sxFld endp

fld$ MACRO DDpointer,DDwidth,DDalign:=<0>       ; Default is align left
    LOCAL rvstring
    .data
        rvstring db MAXWIDTH+4 dup (0)
        align 16
    .code
    invoke sxFld,reparg(DDpointer),ADDR rvstring,DDwidth,DDalign
    EXITM <ADDR rvstring>
ENDM

align 16
start:
    ; make a real test string with all ascii characters-
;    %FOR extra,<0,1,2,3>
;        mov edx,offset str&extra&bLastString
;        mov al,1
;        mov ecx,LastString
;@@:     
;        mov [edx],al
;        inc al
;        .if al==0
;            inc al
;        .endif
;        inc edx
;        dec ecx
;        jnz @b
;    endm        
;         
    print chr$("Test routines for correctness:",13,10)
;    %FOR extra,<0,1,2,3>
;        print chr$("&extra& byte misalignment",13,10)
        %FOR prok,<PROCS>
            print fld$(chr$("&prok&"),HDRWIDTH)
;            %FOR len,<SIZES>
                invoke prok,addr str1, addr str2, 40
                print fld$(sstr$(eax),COLWIDTH,1)
;            ENDM
            print chr$(13,10)
        ENDM
;    ENDM
;
    print chr$(13,10)
    print fld$(chr$("Proc cycles"),HDRWIDTH)
;    print fld$(chr$("Proc/Bytes"),HDRWIDTH)
;
;    %FOR len,<SIZES>
;        invoke HPROC, ADDR str0b&len&
;        print fld$(sstr$(eax),COLWIDTH,1)
;    ENDM
    print chr$(13,10)
;
;    print fld$(chr$("=========="),HDRWIDTH)
;    %FOR len,<SIZES>
;        invoke StrLen,ADDR str0b&len&
;        print fld$(" ====",COLWIDTH)
;    ENDM
;    print chr$(13,10)

;    %FOR extra,<0,1,2,3>
;        print chr$(13,10)
;        print chr$("&extra& byte misalignment",13,10)
       %FOR prok,<PROCS>
            print fld$(chr$("&prok&"),HDRWIDTH)
;            %FOR len,<SIZES>
                counter_begin LOOPCOUNT, HIGH_PRIORITY_CLASS
                invoke prok,addr str1, addr str2, 40
                counter_end
                mov ebx,eax
                print fld$(sstr$(ebx),COLWIDTH,1)
;            ENDM
        print chr$(13,10)
        ENDM
;    ENDM
    mov   eax,input(13,10,"Press enter to exit...")
    exit

; --------------------- Routines under test ---------------------------------------------


; 

align 4

szCmpix proc src:DWORD,dst:DWORD,ln:DWORD

  ; -----------------------------------------------------------
  ; algorithm compares any two byte sequences CASE INSENSITIVE
  ; and returns zero if they are identical or the character
  ; count where the two byte sequences mismatch.
  ; -----------------------------------------------------------

    push ebx
    push esi
    push edi

    sub eax, eax
    sub edx, edx

    mov ebx, OFFSET @_cmpi_table_@  ; table base address
    mov esi, src                    ; 1st string in ESI
    mov edi, dst                    ; 2nd string in EDI
    mov ecx, ln

    push ebp
    mov ebp, -1

  align 4
  @@:
    add ebp, 1
    mov al, [esi+ebp]               ; get 1st byte
    xlatb                           ; replace it with byte in table
    mov dl, al                      ; store it in DL
    mov al, [edi+ebp]               ; get 2nd byte
    xlatb                           ; replace it with byte in table
    sub al, dl                      ; if bytes are the same
    jnz @F                          ; exit the loop
    cmp ebp, ecx                    ; exit on length
    jl @B
  @@:

    mov ecx, ebp
    pop ebp

    cmp ecx, ln
    jnz @F
    xor eax, eax
    jmp quit
  @@:
    lea eax, [ecx+1]

  quit:

    pop edi
    pop esi
    pop ebx

    ret

szCmpix endp

align 16
szCmpix2 proc src:DWORD,dst:DWORD,ln:DWORD

  ; modified xlat to mov eax,[ebx+eax]

    push ebx
    push esi
    push edi

    sub eax, eax
    sub edx, edx

    mov ebx, OFFSET @_cmpi_table_@  ; table base address
    mov esi, src                    ; 1st string in ESI
    mov edi, dst                    ; 2nd string in EDI
    mov ecx, ln

    push ebp
    mov ebp, -1

  align 16
  @@:
    add ebp, 1
    mov al, [esi+ebp]               ; get 1st byte
;    xlatb                           ; replace it with byte in table
	mov al,[ebx+eax]
    mov dl, al                      ; store it in DL
    mov al, [edi+ebp]               ; get 2nd byte
    mov al,[ebx+eax]
;    xlatb                           ; replace it with byte in table
    sub al, dl                      ; if bytes are the same
    jnz @F                          ; exit the loop
    cmp ebp, ecx                    ; exit on length
    jl @B
  @@:

    mov ecx, ebp
    pop ebp

    cmp ecx, ln
    jnz @F
    xor eax, eax
    jmp quit
  @@:
    lea eax, [ecx+1]

  quit:

    pop edi
    pop esi
    pop ebx

    ret

szCmpix2 endp

align 16
szCmpix3 proc src:DWORD,dst:DWORD,ln:DWORD

;	got rid of table completely and used old fashion method

    push esi
    push edi

    sub eax, eax
    sub edx, edx

    mov esi, src                    ; 1st string in ESI
    mov edi, dst                    ; 2nd string in EDI
    mov ecx, ln
    mov edx, -1

  align 16
  @@:
    add edx, 1
    mov al, [esi+edx]               ; get 1st byte
    cmp al,'A'
    jb noupper
    cmp al,'Z'
    ja noupper
    or al,20h
    noupper:
    mov ah, [edi+edx]               ; get 2nd byte
    cmp ah,'A'
    jb noupper2
    cmp ah,'Z'
    ja noupper2
    or ah,20h
    noupper2:
    sub al, ah                      ; if bytes are the same
    jnz @F                          ; exit the loop
    
    cmp edx, ecx                    ; exit on length
    jl @B
  @@:

    cmp edx, ln
    jnz @F
    xor eax, eax
    jmp quit
  @@:
    lea eax, [edx+1]

  quit:

    pop edi
    pop esi

    ret

szCmpix3 endp
end start
